//package bancomat;

// use by typing:
// java5c Banca.java
// java5  Banca 

import java.lang.*;
import java.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

class ContoCorrente {
  private int contoId;
  private String nomeTitolare;
  private String cognomeTitolare;
  private double saldo;
  private String [] ultimeNoperazioni;
  private int numOperazioni;
  private int indicePrimaOpLibera;
  private int indiceUlitimaEffettuata;


  ContoCorrente (int contoId, String nomeTitolare, String cognomeTitolare, 
double saldoIniziale) {
  this.contoId=contoId;
  this.nomeTitolare=nomeTitolare;
  this.cognomeTitolare=cognomeTitolare;
  saldo = saldoIniziale;
  numOperazioni=10;
  ultimeNoperazioni = new String [numOperazioni];
  indicePrimaOpLibera=0;
  indiceUlitimaEffettuata=0;
}


public synchronized String verso (int contoId, double cifra) {
  saldo += cifra;
  ultimeNoperazioni[indicePrimaOpLibera] = "Effettuato versamento di Euro " +
      cifra +
      "\n-- " + new Date() + " --";
  indicePrimaOpLibera++;
  indiceUlitimaEffettuata++;
  indicePrimaOpLibera %= numOperazioni;
    return "L'operazione di versamento di Euro " + cifra +
        "  andata a buon fine";
  }


public synchronized String prelevo (int contoId, double cifra) {
  if (saldo >= cifra) {
    saldo -= cifra;
    ultimeNoperazioni[indicePrimaOpLibera] = "Effettuato prelievo di Euro " +
        cifra +
        "\n-- " + new Date() + "--";
    indicePrimaOpLibera++;
    indiceUlitimaEffettuata++;
    indicePrimaOpLibera %= numOperazioni;
  }
    return "L'operazione di prelievo di Euro " + cifra +
        "  andata a buon fine";
  }


public synchronized double richiedoSaldo (int contoId) {
    return saldo;
  }
public synchronized String [] estrattoOperazioni (int contoId) {
  return ultimeNoperazioni;
}
public int getcontoId () {
  return contoId;
}

public String getNomeTitolare() {
  return nomeTitolare;
}
public String getCognomeTitolare() {
  return cognomeTitolare;
}
public int getnumOperazioni() {
  return numOperazioni;
}
public int trovaIndicePrimaLib() {
  return indicePrimaOpLibera;
}
public int trovaIndiceUltimaEff () {
  return indiceUlitimaEffettuata;
}
}

//////////CLASSE PRINCIPALE//////////
public class Banca extends JFrame implements ActionListener{
private int numTitolariConto;
private ContoCorrente[] titolareConto;
private int codiceAccesso;

JPanel benvenuto = new JPanel(); //Crea il pannello di benvenuto
JLabel istr = new JLabel("Prego inserire il vostro codice:");
JPasswordField campo = new JPasswordField(4);
JButton login = new JButton("Login");

public void actionPerformed(ActionEvent evento) {
  Object src = evento.getSource();
  if (src == login) {
    try {

	String stringaCodice = new String(campo.getPassword());
      codiceAccesso = Integer.parseInt(stringaCodice);
      int codiceCorretto = 0;
      for (int i = 0; i < titolareConto.length; i++) {
        if (codiceAccesso == titolareConto[i].getcontoId()) {
          JFrame sport = new Bancomat(numTitolariConto,
                                      titolareConto[i].getcontoId(),
                                      titolareConto[i].getNomeTitolare(),
                                      titolareConto[i].getCognomeTitolare(),
                                      titolareConto, titolareConto[i]);
          sport.show();
          codiceCorretto = codiceAccesso;
        }
        else if ( (i == (titolareConto.length - 1)) &&
                 (codiceCorretto != codiceAccesso)) {
          JOptionPane.showMessageDialog(null,
                                        "Codice non valido\n" +
                                        "Prego inserire un codice valido..",
                                        "Login non effettuato",
                                        JOptionPane.WARNING_MESSAGE);
        }
      }
    }
    catch (NumberFormatException nfex) {
    }
  }
}

public Banca(String titolo) {
  super(titolo);

  numTitolariConto = 10;
  titolareConto = new ContoCorrente[numTitolariConto];

  titolareConto[0] = new ContoCorrente(1234, "Valentina", "Accili", 5000);
  titolareConto[1] = new ContoCorrente(5678, "Valeria", "Accili", 30000);
  titolareConto[2] = new ContoCorrente(0000, "Paolo", "Rossi", 8440);
  titolareConto[3] = new ContoCorrente(4568, "Alessandra", "Bianchi", 1760);
  titolareConto[4] = new ContoCorrente(1357, "Leo", "Verdi", 3330);
  titolareConto[5] = new ContoCorrente(5478, "Mimmo", "Formica", 8200);
  titolareConto[6] = new ContoCorrente(4441, "Massimo", "Carducci", 1110);
  titolareConto[7] = new ContoCorrente(7845, "Francesco", "Diario", 10000);
  titolareConto[8] = new ContoCorrente(2233, "Daniele", "Liri", 800);
  titolareConto[9] = new ContoCorrente(8585, "Francesca", "Poeta", 19800);

  //impostazione Layout Size e Componenti del pannello iniziale
  benvenuto.setLayout(new FlowLayout());
  benvenuto.add(istr);
  benvenuto.add(campo);
  benvenuto.add(login);
  campo.setEchoChar('*');

  Font mioFont = new Font("Comic Sans MS", 0, 15);
  Color
      ciano = new Color(122, 150, 223),
      blue = new Color(0, 0, 255);
  istr.setFont(mioFont);
  istr.setForeground(blue);
  benvenuto.setBackground(ciano);
  login.setBackground(blue);
  login.setFont(mioFont);
  login.setForeground(ciano);

  //Listener di eventi provenienti dal bottone login e dal textfield campo
  login.addActionListener(this);
  campo.addActionListener(this);

  setContentPane(benvenuto);
  benvenuto.setVisible(true);

}

public static void main(String[] args) {
  JFrame banca = new Banca("Vale & Vale Bank");//Crea il pannello di benvenuto

  banca.setSize(360, 100);
  banca.show();

  WindowListener wl = new WindowAdapter() {
    public void windowClosing(WindowEvent we) {
      System.exit(0);
    }
  };
  banca.addWindowListener(wl);
}
}

class Bancomat extends JFrame implements ActionListener {
  private int numTitolariConto;
  private ContoCorrente[] titolareConto;
  private int codice;
  private ContoCorrente titolare;

  JButton
      prelievo = new JButton("Preleva"),
      versamento = new JButton("Versa"),
      saldo = new JButton("Saldo"),
      ultOp = new JButton("Estratto Operazioni");
  JLabel
      ind = new JLabel(" "),
      ind_prel = new JLabel("Inserire l'importo da prelevare"),
      ind_vers = new JLabel("Inserire l'importo da versare");

  JTextField
      ins_prel = new JTextField(8),
      ins_vers = new JTextField(8);
  JTextArea output = new JTextArea(20,1);

  public void actionPerformed(ActionEvent evento) {
    Object thing = evento.getSource();
    if (thing == prelievo) {
      try {
        double d = Double.parseDouble(ins_prel.getText());
        ins_prel.setText(null);
        if (d > titolare.richiedoSaldo(codice)) {
          JOptionPane.showMessageDialog(null,
            "L'importo richiesto non  disponibile su questo conto\n" +
            "Prego inserire un importo valido e riprovare",
            "Impossibile effettuare il prelievo",
                                        JOptionPane.ERROR_MESSAGE);
        }
        else {
          output.setText("\n" + titolare.prelevo(codice, d));
        }
      }

      catch (NumberFormatException nfex) {
        JOptionPane.showMessageDialog(null,
         "Importo non inserito\n" + "Prego inserire l'importo da prelevare..",
                                      "Impossibile effettuare il prelievo",
                                      JOptionPane.WARNING_MESSAGE);
      }
    }
    if (thing == versamento) {
      try {
        double d = Double.parseDouble(ins_vers.getText());
        ins_vers.setText(null);
        output.setText("\n" + titolare.verso(codice, d));

      }
      catch (NumberFormatException nfex) {
        JOptionPane.showMessageDialog(null, "Importo non inserito\n" +
                                      "Prego inserire l'importo da versare..",
                                      "Impossibile effettuare il versamento",
                                      JOptionPane.WARNING_MESSAGE);
      }
    }
    if (thing == saldo) {
      output.setText("\n" + "Il suo saldo attuale  di: " + 
                     titolare.richiedoSaldo(codice) + " Euro");
    }
    if (thing == ultOp) {
      output.setText(null);
      String[] op = titolare.estrattoOperazioni(codice);
      int n;
      int ind;
      n = Integer.parseInt(JOptionPane.showInputDialog(null,
          "Prego inserire il numero di operazioni " +
          "che si desidera visualizzare " + "\n" + "fino ad un massimo di " + 
           titolare.getnumOperazioni() + " operazioni","Numero Operazioni",
          JOptionPane.INFORMATION_MESSAGE));
      ind = titolare.trovaIndiceUltimaEff();
        if (n >= ind ){
          if(ind < titolare.getnumOperazioni()) {
          for (int i = 0; i < titolare.trovaIndicePrimaLib() ; i++) {
            output.append("\n" + op[i]);
           }
          }
          else {
            for (int i = titolare.trovaIndicePrimaLib(); i < 
                 titolare.getnumOperazioni(); i++) {
              output.append("\n" + op[i]);
            }
            for (int j=0; j<titolare.trovaIndicePrimaLib();j++) {
              output.append("\n" + op[j]);
            }
          }
        }
      else { //n<ind
        if (ind < titolare.getnumOperazioni()) {
          for (int i = titolare.trovaIndicePrimaLib() - n; i < 
               titolare.trovaIndicePrimaLib(); i++) {
            output.append("\n" + op[i]);
          }
        }
        else { //ind>=titolare.numOperazioni
          if(n>(ind-titolare.getnumOperazioni())) {
            for (int i = (titolare.getnumOperazioni() - n +
                          titolare.trovaIndicePrimaLib());
                 i < op.length; i++) {
              output.append("\n" + op[i]);
            }
            for (int j = 0; j < titolare.trovaIndicePrimaLib(); j++) {
              output.append("\n" + op[j]);
            }
          }
          else {
            for (int j = titolare.trovaIndicePrimaLib() - n;
                 j < titolare.trovaIndicePrimaLib(); j++) {
              output.append("\n" + op[j]);
            }
          }
        }
      }
    }
  }


  Bancomat(int n, int contoId, String nome, String cognome,
           ContoCorrente[] titolareConto, ContoCorrente titolare) {
    super("Sportello Bancomat");
    this.numTitolariConto = n;
    this.titolareConto = titolareConto;
    this.codice = contoId;
    this.titolare = titolare;
    JPanel
        pann_1 = new JPanel(),
        pann_2 = new JPanel(),
        pann_3 = new JPanel(),
        pann_31 = new JPanel(),
        pann_32 = new JPanel(),
        pann_33 = new JPanel(),
        pann_34 = new JPanel(),
        inf = new JPanel(),
        sx = new JPanel(),
        dx = new JPanel();
    JLabel
        welcome = new JLabel("Benvenuto " + nome + " " + cognome);
    setBounds(0, 0, 500, 650);
    pann_1.setLayout(new BorderLayout());
    pann_2.setLayout(new BorderLayout());
    pann_3.setLayout(new GridLayout(4, 1));
    pann_31.setLayout(new FlowLayout());
    pann_32.setLayout(new FlowLayout());
    pann_33.setLayout(new FlowLayout());
    pann_33.setLayout(new FlowLayout());

    pann_1.add("North", welcome);
    pann_1.add("Center", pann_2);
    pann_1.add("East", sx);
    pann_1.add("West", dx);
    pann_1.add("South", inf);
    pann_2.add("South", output);
    pann_2.add("Center", pann_3);
    pann_2.add("North", ind);
    pann_3.add("East", pann_31);
    pann_3.add("Center", pann_32);
    pann_3.add("Center", pann_33);
    pann_3.add("South", pann_34);

    pann_31.add(ind_prel);
    pann_31.add(ins_prel);
    pann_31.add(prelievo);
    pann_32.add(ind_vers);
    pann_32.add(ins_vers);
    pann_32.add(versamento);
    pann_33.add(saldo);
    pann_34.add(ultOp);

    Font
        mioFont = new Font("Comic Sans MS", 0, 15),
        mioFont_1 = new Font("Comic Sans MS", 0, 11),
        mioFont_2 = new Font("Comic Sans MS", 0, 28),
        mioFont_3 = new Font("Comic Sans MS", 0, 23);
    Color
        blue = new Color(0, 0, 255),
        ciano = new Color(122, 150, 223);

    welcome.setFont(mioFont_2);
    welcome.setForeground(blue);
    ind.setFont(mioFont_3);
    ind.setForeground(blue);
    pann_1.setVisible(true);
    pann_1.setBackground(ciano);
    pann_2.setVisible(true);
    pann_2.setBackground(ciano);
    pann_3.setVisible(true);
    pann_3.setBackground(ciano);
    pann_31.setVisible(true);
    pann_31.setBackground(ciano);
    pann_32.setVisible(true);
    pann_32.setBackground(ciano);
    pann_33.setVisible(true);
    pann_33.setBackground(ciano);
    pann_34.setVisible(true);
    pann_34.setBackground(ciano);
    sx.setBackground(ciano);
    dx.setBackground(ciano);
    prelievo.setBackground(blue);
    prelievo.setFont(mioFont);
    prelievo.setForeground(ciano);
    versamento.setBackground(blue);
    versamento.setFont(mioFont);
    versamento.setForeground(ciano);
    saldo.setBackground(blue);
    saldo.setFont(mioFont);
    saldo.setForeground(ciano);
    ultOp.setBackground(blue);
    ultOp.setFont(mioFont);
    ultOp.setForeground(ciano);
    ind_prel.setFont(mioFont);
    ind_prel.setForeground(blue);
    ind_vers.setFont(mioFont);
    ind_vers.setForeground(blue);
    output.setFont(mioFont_1);
    output.setForeground(blue);
    output.setEditable(false);
    inf.setBackground(ciano);


    prelievo.addActionListener(this);
    versamento.addActionListener(this);
    saldo.addActionListener(this);
    ultOp.addActionListener(this);
    ins_prel.addActionListener(this);
    ins_vers.addActionListener(this);

    setContentPane(pann_1);
    pann_1.setVisible(true);

    ComponentListener cl = new ComponentAdapter() {
      public void panelClosing(WindowEvent we) {
        System.exit(0);
      }
    };
    pann_1.addComponentListener(cl);
    pann_1.setVisible(true);

  }
}
// ---------------------------------------------------------------------------
